//
//  KloutPassAdapter.h
//  klout-ios-sdk
//
//  Created by Jieren Chen on 9/4/12.
//  Copyright (c) 2012 Klout. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "KloutPassWebView.h"
#import "KloutPassWebViewDelegate.h"
#import "KloutPassAdapterDelegate.h"
#import "KloutPassConstants.h"


typedef enum _KloutPassState {
    //logged out states
    LOGGED_OUT,
    LOGGING_IN,
    REQUESTING_TOKEN,
    //logged in states
    LOGGED_IN,
    REQUESTING_USER
} KloutPassState;


@interface KloutPassAdapter : NSObject<KloutPassWebViewDelegate, NSURLConnectionDelegate>

@property (nonatomic, assign) KloutPassState currentState;
@property (nonatomic, retain) NSString *accessToken;
@property (nonatomic, retain) NSString *apiKey;
@property (nonatomic, retain) NSString *apiSecret;
@property (nonatomic, retain) NSString *apiRedirect;
@property (nonatomic, retain) NSString *currentKloutId;

@property (nonatomic, retain) KloutPassWebView *theView;
@property (nonatomic, retain) UIView *activityView;
@property (nonatomic, retain) UIButton *cancelButton;


@property (nonatomic, retain) id <KloutPassAdapterDelegate> theDelegate;
@property (nonatomic, retain) NSURLConnection *theConnection;
@property (nonatomic, retain) NSMutableData *responseData;


# pragma public methods
- (id) initWithSuperView:(UIView*)superview withDelegate:(id <KloutPassAdapterDelegate>)delegate;
- (void) login;
- (BOOL) isLoggedIn;
- (void) logout;
- (void) requestUser;

# pragma private methods
- (void) requestAccessTokenWithAuthCode:(NSString*)authCode withUser:(NSString*) kloutId;
- (NSString*)generateApiSignature;

@end

