//
//  KloutPassButton.m
//  klout-ios-sdk
//
//  Created by Jieren Chen on 9/14/12.
//  Copyright (c) 2012 Klout. All rights reserved.
//

#import "KloutPassButton.h"
#import "KloutPassAdapter.h"
#import "KloutPassAdapterDelegate.h"

@implementation KloutPassButton

@synthesize theAdapter, apiKey, apiSecret, redirect, theDelegate;

- (void) awakeFromNib 
{
    [self setImage:[UIImage imageNamed:@"klout-pass-button.png"] forState:UIControlStateNormal];
    
    [self addTarget:self action:@selector(performClick:) forControlEvents:UIControlEventTouchUpInside];
    
    assert(self.theDelegate);
        
    self.theAdapter = [[[KloutPassAdapter alloc] initWithSuperView:self.superview withDelegate:self] autorelease];
}

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
    }
    return self;
}

- (void)performClick:(id)sender
{
    
    [self.theAdapter login];
}

#pragma delegate override
- (void) completedLogin
{
	[self.theAdapter requestUser];
}


- (void) completedUserFetch:(NSString*)userPayload
{
	[self.theDelegate completedUserFetch:userPayload];
}

- (void) error:(KloutPassError*)theError
{
	[self.theDelegate error:theError];
}

- (NSString*) apiKey
{
	return [self.theDelegate apiKey];
}

- (NSString*) apiSecret
{
	return [self.theDelegate apiSecret];
}

- (NSString*) redirect
{
	return [self.theDelegate redirect];
}

@end
