//
//  KloutPassError.m
//  klout-ios-sdk
//
//  Created by Jieren Chen on 9/12/12.
//  Copyright (c) 2012 Klout. All rights reserved.
//

#import "KloutPassError.h"

@implementation KloutPassError
@synthesize errorType;

- (id) initWithType:(KloutPassErrorType)type {
    self = [super init];
    if (!self) {        
        return nil;
    }
    else {
        self.errorType = type;
        return self;
    }
}

- (NSString*) domain {    
    return @"com.klout.pass";
}

- (NSInteger)code {
    return self.errorType;
}

-(NSString*)errorMessage {
    switch (self.errorType) {            
        case CONNECTION_FAILURE:
            return @"Failed to create connection";
            break;
        case NOT_LOGGED_IN:
            return @"Not logged in";
            break;
        case ALREADY_LOGGED_IN:
            return @"Already logged in";
            break;
        case ALREADY_REQUESTING_USER:
            return @"Already in the process of requesting user";
            break;
        case ALREADY_REQUESTING_TOKEN:
            return @"Already in the process of requesting token";
            break;
        default:
            return @"Unknown error";
            break;
    }
}

-(NSString*)errorCode {
    switch (self.errorType) {            
        case CONNECTION_FAILURE:
            return @"error.connection";
            break;
        case NOT_LOGGED_IN:
            return @"error.login.not";
            break;
        case ALREADY_LOGGED_IN:
            return @"error.login.already";
            break;
        case ALREADY_REQUESTING_USER:
            return @"error.user-request.already";
            break;
        case ALREADY_REQUESTING_TOKEN:
            return @"error.token-request.already";
            break;
        default:
            return @"error.unknown";
            break;
    }
}


@end
