//
//  KloutPassWebView.m
//  klout-ios-sdk
//
//  Created by Jieren Chen on 9/4/12.
//  Copyright (c) 2012 Klout. All rights reserved.
//

#import "KloutPassWebView.h"
#import "KloutPassConstants.h"

@implementation KloutPassWebView

@synthesize baseRequest, apiRedirect, theDelegate;

- (id) initWithFrame:(CGRect)frame withURL:(NSString*)url withDelegate:(id<KloutPassWebViewDelegate>)del withRedirect:(NSString*)redirect{
    
    self = [super initWithFrame:frame];
    if (!self) {        
        return nil;
    }
    else {
        NSLog(@"base url: %@",url);
        
        self.baseRequest = [[[NSURLRequest alloc] initWithURL:[[NSURL alloc] initWithString:url]] autorelease];
        NSLog(@"%@",self.baseRequest);
        self.apiRedirect = redirect;
        self.hidden = NO;
        self.scalesPageToFit = YES;
        self.theDelegate = del;
        //pre-load that shit            
        
        
        [self setDelegate:self];
        return self;
    }
}

- (void) reset {
    
    if (self.baseRequest != nil) {
        [self loadRequest:self.baseRequest];
    }
    
}

-(BOOL)webView:(UIWebView*)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType {
    
    NSString *URLString = [[request URL] absoluteString];
    NSLog(@"url: %@", URLString);

    NSURL* theURL = [request URL];
    
    
    NSString* strippedURL = [[[theURL absoluteString] componentsSeparatedByString:@"?"] objectAtIndex:0];

    NSLog(@"stripped: %@ relative: %@ query %@", strippedURL, [theURL absoluteString], [theURL query]);
    if ([strippedURL isEqualToString:self.apiRedirect]) {
        NSString* authCode = nil;
        NSString* kloutId = nil;
        
        
        for (NSString *param in [[theURL query] componentsSeparatedByString:@"&"]) {
            NSLog(@"%@", param);
            NSArray *elts = [param componentsSeparatedByString:@"="];
            
            NSString* key = [elts objectAtIndex:0];
            NSString* value = [elts objectAtIndex:1];
            
            if ([key isEqualToString:@"authCode"]) {
                
                authCode = [value copy];
                NSLog(@"authCode: %@",authCode);
                
                
            }            
            else if ([key isEqualToString:@"user"]) {
                kloutId = [value copy];
                NSLog(@"userCode: %@", kloutId);
            }
        }
        
        if (authCode != nil && kloutId != nil) {
            self.hidden = YES;
            [self reset];
            [self.theDelegate completedWithAuthCode:authCode withKloutId:kloutId];
        }
        
        return NO;
    }
    else if ([[theURL host] isEqualToString:BASE_URL] ||
             [[theURL host] isEqualToString:@"www.facebook.com"] || 
             [[theURL host] isEqualToString:@"graph.facebook.com"] || 
             [[theURL host] isEqualToString:@"m.facebook.com"] || 
             [[theURL host] isEqualToString:@"www.twitter.com"] || 
             [[theURL host] isEqualToString:@"api.twitter.com"]){
        return YES;
    }
    else {
        NSLog(@"%@",strippedURL);
        //If we stray from our API calls, cancel request
        //This happens when user clicks cancel on permissions page
        [self.theDelegate cancel:self];
        return NO;
    }
}

- (void)webViewDidStartLoad:(UIWebView *)webView
{
    [self.theDelegate webViewDidStartLoad:webView];
    
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
    [self.theDelegate webViewDidFinishLoad:webView];
}


- (void) dealloc {
    self.baseRequest = nil;
    self.theDelegate = nil;
    self.apiRedirect = nil;
    [super dealloc];
    
}
@end
